/*
 * Rs[^bK 4-5: \̂ɂ镪̕\Ƃ֐ (|C^ł2)
 * 2005N626        @
 * 2003N71        J ۔
 */

#include <stdio.h>
#include <stdlib.h>

/* \\̂ւ̃|C^fractionpƂO */
typedef struct {
    int   n;    /* q (numerator) */
    int   d;    /*  (denominator) */
} *fractionp;

/* O̊֐̃vg^Cv錾 */
fractionp fracAlloc(int n);
void      fracFree(fractionp p);
fractionp fracMake(fractionp p, int n, int d);
void      fracPrint(fractionp p);
fractionp fracAdd(fractionp po, fractionp p1, fractionp p2);
fractionp fracMul(fractionp po, fractionp p1, fractionp p2);
fractionp fracReduce(fractionp p);
int       gcd(int x, int y);

int
main(void)
{
    fractionp    x1, x2, x3, t1, t2;

    /* e|C^w߂̗̈m */
    x1 = fracAlloc(1);
    x2 = fracAlloc(1);
    x3 = fracAlloc(1);
    t1 = fracAlloc(1);
    t2 = fracAlloc(1);

    /* x1, x2ɒlݒ */
    fracMake(x1, 3,  4);
    fracMake(x2, 5, -6);
    printf("x1 = "); fracPrint(x1); printf("\n");
    printf("x2 = "); fracPrint(x2); printf("\n");

    /* a̓mF */
    fracAdd(x3, x1, x2);
    printf("x1 + x2 = "); fracPrint(x3); printf("\n");

    /* ς̓mF */
    fracMul(x3, x1, x2);
    printf("x1 * x2 = "); fracPrint(x3); printf("\n");

    /* aƐς̍̓mF x3 = x1*x1 + x2*x2
     * fracMul(t1, x1, x1);
     * fracMul(t2, x2, x2);
     * fracAdd(x3, t1, t2); Ɠ
     */
    fracAdd(x3, fracMul(t1, x1, x1), fracMul(t2, x2, x2));
    printf("x1*x1 + x2*x2 = "); fracPrint(x3); printf("\n");

    /* mۂ̈̉ */
    fracFree(x1);
    fracFree(x2);
    fracFree(x3);
    fracFree(t1);
    fracFree(t2);

    return 0;
}

/*
 * ̗̈m:
 * fractionp̎weni[̈mۂD
 * ߂ĺC̈̐擪̃|C^D
 */
fractionp
fracAlloc(int n)
{
    /*
     * AhX͉ł\Ȃ̂fractionp^̎ẅ̃TCY
     * (sizeof(*fractionp)0)Cn{̗̈mۂCfractionp^
     * LXgD
     */
    return (fractionp)malloc(sizeof(*(fractionp)0)*n);
}

/*
 * ̗̈:
 * ꐫ߂邽߂Ɋ֐ɂD
 */
void
fracFree(fractionp p)
{
    free(p);
}

/*
 * ̑:
 * n𕪎qCd𕪕Ƃp̎wꏊɐݒ肷D߂lp
 * example42.cɍ킹fracMakeƂOɂĂ邪CӖ̏ォ
 * fracCopyƂłׂłD
 */
fractionp 
fracMake(fractionp p, int n, int d)
{
    p->n = n;
    p->d = d;

    return p;
}

/*
 * ̕\: p̎we\
 * ꂪ̏ꍇ̕\lĂȂD
 */
void
fracPrint(fractionp p)
{
    printf("%d/%d", p->n, p->d);
}

/*
 * ̘a:
 * p1̎ŵp2̎w̘apo̎wꏊɐݒ肷D߂lpo.
 */
fractionp 
fracAdd(fractionp po, fractionp p1, fractionp p2)
{
    po->n = (p1->n)*(p2->d) + (p2->n)*(p1->d);
    po->d = (p1->d)*(p2->d);

    return fracReduce(po);
}

/*
 * ̐:
 * p1̎ŵp2̎w̐ςpo̎wꏊɐݒ肷D߂lpo.
 */
fractionp 
fracMul(fractionp po, fractionp p1, fractionp p2)
{
    po->n = (p1->n)*(p2->n);
    po->d = (p1->d)*(p2->d);

    return fracReduce(po);
}

/*
 * ̖:
 * p̎we񕪂ďD߂lp.
 */
fractionp 
fracReduce(fractionp p)
{
    int      g;

    g = gcd(abs(p->n), abs(p->d));
    if ( (p->d) > 0 ) {
        p->n /= g;
        p->d /= g;
    } else {
        p->n /= -g;
        p->d /= -g;
    }

    return p;
}

/*
 * ő: xy̍ő񐔂߂lƂ
 */
int
gcd(int x, int y)
{
    int t;

    while ( y != 0 ) {
        t = x % y;
        x = y;
        y = t;
    }

    return x;
}
